Index: kern/kern_uuid.c
===================================================================
RCS file: /cvsroot/src/sys/kern/kern_uuid.c,v
retrieving revision 1.17
diff -u -b -r1.17 kern_uuid.c
--- kern/kern_uuid.c	4 May 2010 19:23:56 -0000	1.17
+++ kern/kern_uuid.c	31 Oct 2011 04:29:24 -0000
@@ -44,6 +44,7 @@
 #include <sys/mount.h>
 #include <sys/syscallargs.h>
 #include <sys/uio.h>
+#include <sys/cprng.h>
 
 #include <net/if.h>
 #include <net/if_dl.h>
@@ -126,7 +127,7 @@
 	splx(s);
 
 	for (i = 0; i < (UUID_NODE_LEN>>1); i++)
-		node[i] = (uint16_t)arc4random();
+		node[i] = (uint16_t)cprng_fast32();
 	*((uint8_t*)node) |= 0x01;
 }
 
@@ -165,7 +166,7 @@
 	if (uuid_last.time.ll == 0LL || uuid_last.node[0] != uuid->node[0] ||
 	    uuid_last.node[1] != uuid->node[1] ||
 	    uuid_last.node[2] != uuid->node[2])
-		uuid->seq = (uint16_t)arc4random() & 0x3fff;
+		uuid->seq = (uint16_t)cprng_fast32() & 0x3fff;
 	else if (uuid_last.time.ll >= xtime)
 		uuid->seq = (uuid_last.seq + 1) & 0x3fff;
 	else
Index: kern/subr_cprng.c
===================================================================
RCS file: kern/subr_cprng.c
diff -N kern/subr_cprng.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ kern/subr_cprng.c	31 Oct 2011 04:29:24 -0000
@@ -0,0 +1,186 @@
+/*	$NetBSD: $ */
+
+/*-
+ * Copyright (c) 2011 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Thor Lancelot Simon.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <sys/types.h>
+#include <sys/time.h>
+#include <sys/param.h>
+#include <sys/kernel.h>
+#include <sys/systm.h>
+#include <sys/kmem.h>
+#include <sys/mutex.h>
+#include <sys/rngtest.h>
+#include <sys/rnd.h>
+
+#include <machine/cpu_counter.h>
+
+#include <sys/cprng.h>
+
+void
+cprng_init(void)
+{
+	nist_ctr_initialize();
+}
+
+static inline uint32_t
+cprng_counter(void)
+{
+	struct timeval tv;
+
+#if defined(__HAVE_CPU_COUNTER)
+	if (cpu_hascounter())
+		return cpu_counter32();
+#endif
+	if (__predict_false(cold)) {
+		/* microtime unsafe if clock not running yet */
+		return 0;
+	}
+	microtime(&tv);
+	return (tv.tv_sec * 1000000 + tv.tv_usec);
+}
+
+static void
+cprng_strong_reseed(void *arg)
+{
+	cprng_strong_t *c = arg;
+	uint8_t key[NIST_BLOCK_KEYLEN_BYTES];
+	uint32_t cc = cprng_counter();;
+
+	mutex_enter(&c->mtx);
+	if (c->reseed.len != sizeof(key)) {
+		panic("cprng_strong_reseed: bad entropy length %d "
+		      " (expected %d)", (int)c->reseed.len, (int)sizeof(key));
+	}
+	if (nist_ctr_drbg_reseed(&c->drbg, c->reseed.data, c->reseed.len,
+				 &cc, sizeof(cc))) {
+		panic("cprng %s: nist_ctr_drbg_reseed failed.", c->name);
+	}
+	c->reseed_pending = 0;
+	mutex_exit(&c->mtx);
+}
+
+cprng_strong_t *
+cprng_strong_create(const char *const name, int ipl)
+{
+	cprng_strong_t *c;
+	uint8_t key[NIST_BLOCK_KEYLEN_BYTES];
+	int r, getmore = 0;;
+	uint32_t cc;
+
+	c = kmem_alloc(sizeof(*c), KM_NOSLEEP);
+	if (c == NULL) {
+		return NULL;
+	}
+	strlcpy(c->name, name, sizeof(c->name));
+	c->reseed.cb = cprng_strong_reseed;
+	c->reseed.arg = c;
+	strlcpy(c->reseed.name, name, sizeof(c->reseed.name));
+
+	mutex_init(&c->mtx, MUTEX_DEFAULT, ipl);
+	r = rnd_extract_data(key, sizeof(key), RND_EXTRACT_GOOD);
+	if (r != sizeof(key)) {
+		printf("cprng %s: WARNING insufficient "
+		       "entropy at creation.\n", name);
+		rnd_extract_data(key + r, sizeof(key - r), RND_EXTRACT_ANY);
+		getmore++;
+	}
+		
+	if (nist_ctr_drbg_instantiate(&c->drbg, key, sizeof(key),
+				      &cc, sizeof(cc), name, strlen(name))) {
+		panic("cprng %s: instantiation failed.", name);
+	}
+
+	if (getmore) {
+		/* Ask for more. */
+		c->reseed.len = sizeof(key);
+		rndsink_attach(&c->reseed);
+	}
+	return c;
+}
+
+
+size_t
+cprng_strong(cprng_strong_t *c, void *p, size_t len)
+{
+	uint32_t cc = cprng_counter();
+
+	mutex_enter(&c->mtx);
+
+	if (nist_ctr_drbg_generate(&c->drbg, p, len, &cc, sizeof(cc))) {
+		panic("cprng %s: nist_ctr_drbg_generate failed!", c->name);
+	}
+
+	/*
+	 * If the generator has just been keyed, perform
+	 * the statistical RNG test.
+	 */
+	if (__predict_false(c->drbg.reseed_counter == 1)) {
+		rngtest_t rt;
+
+		strncpy(rt.rt_name, c->name, sizeof(rt.rt_name));
+
+		if (nist_ctr_drbg_generate(&c->drbg, rt.rt_b,
+		    sizeof(rt.rt_b), NULL, 0)) {
+			panic("cprng %s: nist_ctr_drbg_generate failed!",
+			      c->name);
+		}
+		if (rngtest(&rt)) {
+			panic("cprng %s: failed statistical RNG test.",
+			      c->name);
+		}
+
+		memset(&rt, 0, sizeof(rt));
+	}
+
+	if (__predict_false(c->drbg.reseed_counter >
+			    (NIST_CTR_DRBG_RESEED_INTERVAL / 2))) {
+		if (!(c->reseed_pending)) {
+			c->reseed.len = NIST_BLOCK_KEYLEN_BYTES;
+			rndsink_attach(&c->reseed);
+		}
+	}
+
+	mutex_exit(&c->mtx);
+	return len;
+}
+
+void
+cprng_strong_destroy(cprng_strong_t *c)
+{
+	mutex_enter(&c->mtx);
+	if (c->reseed_pending) {
+		rndsink_detach(&c->reseed);
+	}
+	mutex_exit(&c->mtx);
+	mutex_destroy(&c->mtx);
+	nist_ctr_drbg_destroy(&c->drbg);
+	memset(c, 0, sizeof(*c));
+	kmem_free(c, sizeof(*c));
+}
Index: kern/subr_rngtest.c
===================================================================
RCS file: kern/subr_rngtest.c
diff -N kern/subr_rngtest.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ kern/subr_rngtest.c	31 Oct 2011 04:29:24 -0000
@@ -0,0 +1,269 @@
+/*	$NetBSD: $ */
+
+/*-
+ * Copyright (c) 2011 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Thor Lancelot Simon.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/* fips140.c	1.5 (Qualcomm) 02/09/02 */
+/*
+This software is free for commercial and non-commercial use
+subject to the following conditions.
+
+Copyright remains vested in QUALCOMM Incorporated, and Copyright
+notices in the code are not to be removed.  If this package is used in
+a product, QUALCOMM should be given attribution as the author this
+software.  This can be in the form of a textual message at program
+startup or in documentation (online or textual) provided with the
+package.
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions are
+met:
+
+1. Redistributions of source code must retain the copyright notice,
+   this list of conditions and the following disclaimer.
+
+2. Redistributions in binary form must reproduce the above copyright
+   notice, this list of conditions and the following disclaimer in the
+   documentation and/or other materials provided with the
+   distribution.
+
+3. All advertising materials mentioning features or use of this
+   software must display the following acknowledgement:  This product
+   includes software developed by QUALCOMM Incorporated.
+
+THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
+WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
+INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGE.
+
+The license and distribution terms for any publically available version
+or derivative of this code cannot be changed, that is, this code cannot
+simply be copied and put under another distribution license including
+the GNU Public License.
+*/
+
+/* Run FIPS 140 statistical tests on a file */
+
+/* written by Greg Rose, Copyright C 2000 QUALCOMM Incorporated */
+
+/*
+ * Modified for in-kernel use (API adjustments, conversion from
+ * floating to fixed-point chi-sq computation) by Thor Lancelot
+ * Simon.
+ *
+ * A comment on appropriate use of this test and the infamous FIPS 140
+ * "continuous output test" (COT):  Both tests are very appropriate for
+ * software interfaces to hardware implementations, and will quickly tell
+ * you if any number of very bad things have happened to your RNG: perhaps
+ * it has come disconnected from the rest of the system, somehow, and you
+ * are getting only unconditioned bus noise (read: clock edges from the
+ * loudest thing in your system).  Perhaps it has ceased to latch a shift
+ * register and is feeding you the same data over and over again.  Perhaps
+ * it is not really random at all but was sold to you as such.  Perhaps it
+ * is not actually *there* (Intel chipset RNG anyone?) but claims to be,
+ * and is feeding you 01010101 on every register read.
+ *
+ * However, when applied to software RNGs, the situation is quite different.
+ * Most software RNGs use a modern hash function or cipher as an output
+ * stage.  The resulting bitstream assuredly *should* pass both the
+ * "continuous output" (no two consecutive samples identical) and
+ * statistical tests: if it does not, the cryptographic primitive or its
+ * implementation is terribly broken.
+ *
+ * There is still value to this test: it will tell you if you inadvertently
+ * terribly break your implementation of the software RNG.  Which is a thing
+ * that has in fact happened from time to time, even to the careful (or
+ * paranoid).  But it will not tell you if there is a problem with the
+ * _input_ to that final cryptographic primitive -- the bits that are hashed
+ * or the key to the cipher -- and if an adversary can find one, you're
+ * still toast.
+ *
+ * The situation is -- sadly -- similar with hardware RNGs that are
+ * certified to one of the standards such as X9.31 or SP800-90.  In these
+ * cases the hardware vendor has hidden the actual random bitstream behind
+ * a hardware cipher/hash implementation that should, indeed, produce good
+ * quality random numbers that pass will pass this test -- whether the
+ * underlying bitstream is trustworthy or not.
+ *
+ * However, this test (and the COT) will still probably tell you if the
+ * thing fell off the bus, etc.  Which is a thing that has in fact
+ * happened from time to time, even to the fully certified...
+ *
+ * This module does not (yet?) implement the Continuous Output Test.  When
+ * I call that test "infamous", it's because it obviously reduces the
+ * backtracking resistance of any implementation that includes it -- the
+ * implementation has to store the entire previous RNG output in order to
+ * perform the required comparison; not just periodically but all the time
+ * when operating at all.  Nonetheless, it has obvious value for
+ * hardware implementations where it will quickly and surely detect a
+ * severe failure; but as of this writing several of the latest comments
+ * on SP800-90 recommend removing any requirement for the COT and my
+ * personal tendency is to agree.  It's easy to add if you really need it.
+ * 
+ */
+
+#include <sys/types.h>
+#include <sys/systm.h>
+#include <sys/rngtest.h>
+
+int	bitnum = 0;
+
+const int minrun[7] = { 0, 2315, 1114, 527, 240, 103, 103 };
+const int maxrun[7] = { 0, 2685, 1386, 723, 384, 209, 209 };
+#define LONGRUN	26
+#define MINONES 9725
+#define MAXONES 10275
+#define MINPOKE 2.16
+#define MAXPOKE 46.17
+#define PRECISION 100000
+
+const int longrun = LONGRUN;
+const int minones = MINONES;
+const int maxones = MAXONES;
+const long long minpoke = (MINPOKE * PRECISION);
+const long long maxpoke = (MAXPOKE * PRECISION);
+
+/* Population count of 1's in a byte */
+const unsigned char Popcount[] = {
+ 0, 1, 1, 2, 1, 2, 2, 3, 1, 2, 2, 3, 2, 3, 3, 4,
+ 1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5,
+ 1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5,
+ 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6,
+ 1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5,
+ 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6,
+ 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6,
+ 3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7,
+ 1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5,
+ 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6,
+ 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6,
+ 3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7,
+ 2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6,
+ 3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7,
+ 3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7,
+ 4, 5, 5, 6, 5, 6, 6, 7, 5, 6, 6, 7, 6, 7, 7, 8
+};
+
+/* end of run */
+static void
+endrun(rngtest_t *const rc, const int last, int run)
+{
+    if (run >= longrun) {
+	printf("Kernel RNG \"%s\" long run test FAILURE: "
+	       "Run of %d %ds found\n", rc->rt_name, run, last);
+	++rc->rt_nerrs;
+    }
+    if (run > 6)
+	run = 6;
+    ++rc->rt_runs[last][run];
+}
+
+int
+rngtest(rngtest_t *const rc)
+{
+    int		i;
+    uint8_t *	p;
+    int		c;
+    long long	X;
+    int		last;
+    int		run;
+
+    /* Enforce sanity for most members of the context */
+    memset(rc->rt_poker, 0, sizeof(rc->rt_poker));
+    memset(rc->rt_runs, 0, sizeof(rc->rt_runs));
+    rc->rt_nerrs = 0;
+    rc->rt_name[sizeof(rc->rt_name) - 1] = '\0';
+
+    /* monobit test */
+    for (p = rc->rt_b, c = 0; p < &rc->rt_b[sizeof rc->rt_b]; ++p)
+	c += Popcount[*p];
+    if (c <= minones || maxones <= c) {
+	printf("Kernel RNG \"%s\" monobit test FAILURE: %d ones\n",
+	       rc->rt_name,  c);
+	++rc->rt_nerrs;
+    }
+    
+    /* poker test */
+    for (p = rc->rt_b; p < &rc->rt_b[sizeof rc->rt_b]; ++p) {
+	++rc->rt_poker[*p & 0xF];
+	++rc->rt_poker[(*p >> 4) & 0xF];
+    }
+    for (X = i = 0; i < 16; ++i) {
+	X += rc->rt_poker[i] * rc->rt_poker[i];
+    }
+    X *= PRECISION;
+    X = 16 * X / 5000 - 5000 * PRECISION;
+    if (X <= minpoke || maxpoke <= X) {
+	printf("Kernel RNG \"%s\" poker test failure: "
+	       "parameter X = %lld.%lld\n", rc->rt_name,
+		(X / PRECISION), (X % PRECISION));
+	++rc->rt_nerrs;
+    }
+
+    /* runs test */
+    last = (rc->rt_b[0] >> 7) & 1;
+    run = 0;
+    for (p = rc->rt_b; p < &rc->rt_b[sizeof rc->rt_b]; ++p) {
+	c = *p;
+	for (i = 7; i >= 0; --i) {
+	    if (((c >> i) & 1) != last) {
+		endrun(rc, last, run);
+		run = 0;
+		last = (c >> i) & 1;
+	    }
+	    ++run;
+	}
+    }
+    endrun(rc, last, run);
+
+    for (run = 1; run <= 6; ++run) {
+	for (last = 0; last <= 1; ++last) {
+	    if (rc->rt_runs[last][run] <= minrun[run]) {
+		printf("Kernel RNG \"%s\" runs test FAILURE: "
+		    "too few runs of %d %ds (%d < %d)\n", rc->rt_name,
+		    run, last, rc->rt_runs[last][run], minrun[run]);
+		++rc->rt_nerrs;
+	    }
+	    else if (rc->rt_runs[last][run] >= maxrun[run]) {
+		printf("Kernel RNG \"%s\" runs test FAILURE: "
+		       "too many runs of %d %ds (%d > %d)\n", rc->rt_name,
+		       run, last, rc->rt_runs[last][run], maxrun[run]);
+		++rc->rt_nerrs;
+	    }
+	}
+    }
+    memset(rc->rt_b, 0, sizeof(rc->rt_b));
+    return rc->rt_nerrs;
+}
Index: lib/libkern/arc4random.c
===================================================================
RCS file: /cvsroot/src/sys/lib/libkern/arc4random.c,v
retrieving revision 1.21
diff -u -b -r1.21 arc4random.c
--- lib/libkern/arc4random.c	18 Jan 2010 20:54:54 -0000	1.21
+++ lib/libkern/arc4random.c	31 Oct 2011 04:29:24 -0000
@@ -1,7 +1,7 @@
 /*	$NetBSD: arc4random.c,v 1.21 2010/01/18 20:54:54 joerg Exp $	*/
 
 /*-
- * Copyright (c) 2002 The NetBSD Foundation, Inc.
+ * Copyright (c) 2002, 2011 The NetBSD Foundation, Inc.
  * All rights reserved.
  *
  * This code is derived from software contributed to The NetBSD Foundation
@@ -57,15 +57,42 @@
 #endif
 #include <sys/systm.h>
 
+#ifdef _KERNEL
+#include <sys/mutex.h>
+#include <sys/rngtest.h>
+#else
+#define mutex_spin_enter(x) ;
+#define mutex_spin_exit(x) ;
+#define mutex_init(x, y, z) ;
+#endif
+
 #include <lib/libkern/libkern.h>
 
 #if NRND > 0
 #include <sys/rnd.h>
+
+rndsink_t	rs;
+
 #endif
 
-#define	ARC4_MAXRUNS 16384
+/*
+ * The best known attack that distinguishes RC4 output from a random
+ * bitstream requires 2^25 bytes.  (see Paul and Preneel, Analysis of
+ * Non-fortuitous Predictive States of the RC4 Keystream Generator.
+ * INDOCRYPT 2003, pp52 – 67).
+ *
+ * However, we discard the first 1024 bytes of output, avoiding the
+ * biases detected in this paper.  The best current attack that
+ * can distinguish this "RC4[drop]" output seems to be Fleuhrer &
+ * McGrew's attack which requires 2^30.6 bytes of output:
+ * Fluhrer and McGrew, Statistical Analysis of the Alleged RC4
+ * Keystream Generator. FSE 2000, pp19 – 30
+ *
+ * We rekey at 2^24 bytes.
+ */
+#define	ARC4_MAXBYTES		(16 * 1024 * 1024)
 #define	ARC4_RESEED_SECONDS 300
-#define	ARC4_KEYBYTES 32 /* 256 bit key */
+#define	ARC4_KEYBYTES		16 /* 128 bit key */
 
 #ifdef _STANDALONE
 #define	time_uptime	1	/* XXX ugly! */
@@ -73,11 +100,17 @@
 
 static u_int8_t arc4_i, arc4_j;
 static int arc4_initialized = 0;
-static int arc4_numruns = 0;
+static int arc4_numbytes = 0;
 static u_int8_t arc4_sbox[256];
 static time_t arc4_nextreseed;
 
+#ifdef _KERNEL
+kmutex_t	arc4_mtx;
+#endif
+
 static inline u_int8_t arc4_randbyte(void);
+static inline void arc4randbytes_unlocked(void *, size_t);
+
 
 static inline void
 arc4_swap(u_int8_t *a, u_int8_t *b)
@@ -93,55 +126,73 @@
  * Stir our S-box.
  */
 static void
-arc4_randrekey(void)
+arc4_randrekey(void *arg)
 {
 	u_int8_t key[256];
-	static int cur_keybytes;
-	int n, byteswanted;
+	int n, ask_for_more = 0;
+#ifdef _KERNEL
+	rngtest_t rt;
+#endif
 #if NRND > 0
+	static int callback_pending;
 	int r;
 #endif
 
-	if(!arc4_initialized)
-		/* The first time through, we must take what we can get */
-		byteswanted = 0;
-	else
-		/* Don't rekey with less entropy than we already have */
-		byteswanted = cur_keybytes;
-
 #if NRND > 0	/* XXX without rnd, we will key from the stack, ouch! */
-	r = rnd_extract_data(key, ARC4_KEYBYTES, RND_EXTRACT_GOOD);
+	/*
+	 * The first time through, we must take what we can get,
+	 * so schedule ourselves for callback no matter what.
+	 */
+	if (!arc4_initialized) {
+		ask_for_more = 1;
+		r = rnd_extract_data(key, ARC4_KEYBYTES, RND_EXTRACT_ANY);
+		goto got_entropy;
+	}
 
+	KASSERT(arg == NULL || (arg == &rs && callback_pending == 1));
+	if (arg == NULL) {
+		r = rnd_extract_data(key, ARC4_KEYBYTES, RND_EXTRACT_GOOD);
 	if (r < ARC4_KEYBYTES) {
-		if (r >= byteswanted) {
-			(void)rnd_extract_data(key + r,
-					       ARC4_KEYBYTES - r,
-					       RND_EXTRACT_ANY);
+			ask_for_more = 1;
+		}
 		} else {
-			/* don't replace a good key with a bad one! */
-			arc4_nextreseed = time_uptime + ARC4_RESEED_SECONDS;
-			arc4_numruns = 0;
-			/* we should just ask rnd(4) to rekey us when
-			   it can, but for now, we'll just try later. */
-			return;
+		ask_for_more = 0;
+		if (rs.len != ARC4_KEYBYTES) {
+			panic("arc4_randrekey: rekey callback bad length");
 		}
+		memcpy(key, rs.data, rs.len);
 	}
+#endif
 
-	cur_keybytes = r;
+got_entropy:
+	if (__predict_true(arc4_initialized)) {
+		mutex_spin_enter(&arc4_mtx);
+	}
+	if (ask_for_more) {
+		KASSERT(!callback_pending);
+		callback_pending = 1;
+		strlcpy(rs.name, "arc4random", sizeof(rs.name));
+		rs.cb = arc4_randrekey;
+		rs.arg = &rs;
+		rs.len = ARC4_KEYBYTES;
+		rndsink_attach(&rs);
+	} else {
+		callback_pending = 0;
+	}
 
+	/*
+	 * If it's the first time, or we got a good key, actually rekey.
+	 */
+	if (!ask_for_more || !arc4_initialized) {
 	for (n = ARC4_KEYBYTES; n < sizeof(key); n++)
 			key[n] = key[n % ARC4_KEYBYTES];
-#endif
+
 	for (n = 0; n < 256; n++) {
 		arc4_j = (arc4_j + arc4_sbox[n] + key[n]) % 256;
 		arc4_swap(&arc4_sbox[n], &arc4_sbox[arc4_j]);
 	}
 	arc4_i = arc4_j;
 
-	/* Reset for next reseed cycle. */
-	arc4_nextreseed = time_uptime + ARC4_RESEED_SECONDS;
-	arc4_numruns = 0;
-
 	/*
 	 * Throw away the first N words of output, as suggested in the
 	 * paper "Weaknesses in the Key Scheduling Algorithm of RC4"
@@ -149,6 +200,28 @@
 	 */
 	for (n = 0; n < 256 * 4; n++)
 		arc4_randbyte();
+
+		/* Reset for next reseed cycle. */
+		arc4_nextreseed = time_uptime + ARC4_RESEED_SECONDS;
+		arc4_numbytes = 0;
+#ifdef _KERNEL
+		/*
+		 * Perform the FIPS 140-2 statistical RNG test; warn if our
+		 * output has such poor quality as to fail the test.
+		 */
+		arc4randbytes_unlocked(rt.rt_b, sizeof(rt.rt_b));
+		strlcpy(rt.rt_name, "arc4random", sizeof(rt.rt_name));
+		if (rngtest(&rt)) {
+			/* rngtest will scream to the console. */
+			arc4_nextreseed = time_uptime;
+			arc4_numbytes = ARC4_MAXBYTES;
+			/* XXX should keep old context around, *NOT* use new */
+		}
+#endif
+	}
+	if (__predict_true(arc4_initialized)) {
+		mutex_spin_exit(&arc4_mtx);
+	}
 }
 
 /*
@@ -159,11 +232,12 @@
 {
 	int n;
 
+	mutex_init(&arc4_mtx, MUTEX_DEFAULT, IPL_VM);
 	arc4_i = arc4_j = 0;
 	for (n = 0; n < 256; n++)
 		arc4_sbox[n] = (u_int8_t) n;
 
-	arc4_randrekey();
+	arc4_randrekey(NULL);
 	arc4_initialized = 1;
 }
 
@@ -187,40 +261,40 @@
 u_int32_t
 arc4random(void)
 {
-	u_int32_t ret;
-	int i;
+    int ret;
+    u_int8_t *retc;
 
-	/* Initialize array if needed. */
-	if (!arc4_initialized)
-		arc4_init();
+    retc = (u_int8_t *)&ret;
 
-	if ((++arc4_numruns > ARC4_MAXRUNS) ||
-	    (time_uptime > arc4_nextreseed)) {
-		arc4_randrekey();
-	}
+    arc4randbytes(retc, sizeof(u_int32_t));
+    return ret;
+}
+
+static inline void
+arc4randbytes_unlocked(void *p, size_t len)
+{
+	u_int8_t *buf = (u_int8_t *)p;
+	size_t i;
 
-	for (i = 0, ret = 0; i <= 24; ret |= arc4_randbyte() << i, i += 8)
+	for (i = 0; i < len; buf[i] = arc4_randbyte(), i++)
 		continue;
-	return ret;
 }
 
 void
 arc4randbytes(void *p, size_t len)
 {
-	u_int8_t *buf;
-	size_t i;
-
 	/* Initialize array if needed. */
-	if (!arc4_initialized)
+	if (!arc4_initialized) {
 		arc4_init();
-
-	buf = (u_int8_t *)p;
-
-	for (i = 0; i < len; buf[i] = arc4_randbyte(), i++)
-		continue;
-	arc4_numruns += len / sizeof(u_int32_t);
-	if ((arc4_numruns > ARC4_MAXRUNS) ||
+                /* avoid conditionalizing locking */
+		return arc4randbytes_unlocked(p, len);
+	}
+	mutex_spin_enter(&arc4_mtx);
+	arc4randbytes_unlocked(p, len);
+	arc4_numbytes += len;
+	mutex_spin_exit(&arc4_mtx);
+	if ((arc4_numbytes > ARC4_MAXBYTES) ||
 	    (time_uptime > arc4_nextreseed)) {
-		arc4_randrekey();
+		arc4_randrekey(NULL);
 	}
 }
Index: net/if_bridge.c
===================================================================
RCS file: /cvsroot/src/sys/net/if_bridge.c,v
retrieving revision 1.73
diff -u -b -r1.73 if_bridge.c
--- net/if_bridge.c	23 May 2011 21:52:54 -0000	1.73
+++ net/if_bridge.c	31 Oct 2011 04:29:25 -0000
@@ -100,6 +100,7 @@
 #include <sys/pool.h>
 #include <sys/kauth.h>
 #include <sys/cpu.h>
+#include <sys/cprng.h>
 
 #include <net/bpf.h>
 #include <net/if.h>
@@ -1848,7 +1849,7 @@
 	for (i = 0; i < BRIDGE_RTHASH_SIZE; i++)
 		LIST_INIT(&sc->sc_rthash[i]);
 
-	sc->sc_rthash_key = arc4random();
+	sc->sc_rthash_key = cprng_fast32();
 
 	LIST_INIT(&sc->sc_rtlist);
 
Index: net/if_spppsubr.c
===================================================================
RCS file: /cvsroot/src/sys/net/if_spppsubr.c,v
retrieving revision 1.123
diff -u -b -r1.123 if_spppsubr.c
--- net/if_spppsubr.c	28 Oct 2011 22:08:14 -0000	1.123
+++ net/if_spppsubr.c	31 Oct 2011 04:29:25 -0000
@@ -66,6 +66,7 @@
 #include <sys/md5.h>
 #include <sys/inttypes.h>
 #include <sys/kauth.h>
+#include <sys/cprng.h>
 
 #include <net/if.h>
 #include <net/netisr.h>
@@ -1202,7 +1203,7 @@
 			++sp->pp_loopcnt;
 
 			/* Generate new local sequence number */
-			sp->pp_seq[IDX_LCP] = arc4random();
+			sp->pp_seq[IDX_LCP] = cprng_fast32();
 			break;
 		}
 		sp->pp_loopcnt = 0;
@@ -2481,7 +2482,7 @@
 				if (magic == ~sp->lcp.magic) {
 					if (debug)
 						addlog(" magic glitch");
-					sp->lcp.magic = arc4random();
+					sp->lcp.magic = cprng_fast32();
 				} else {
 					sp->lcp.magic = magic;
 					if (debug)
@@ -2665,7 +2666,7 @@
 
 	if (sp->lcp.opts & (1 << LCP_OPT_MAGIC)) {
 		if (! sp->lcp.magic)
-			sp->lcp.magic = arc4random();
+			sp->lcp.magic = cprng_fast32();
 		opt[i++] = LCP_OPT_MAGIC;
 		opt[i++] = 6;
 		opt[i++] = sp->lcp.magic >> 24;
@@ -4229,7 +4230,7 @@
 		 * Compute the re-challenge timeout.  This will yield
 		 * a number between 300 and 810 seconds.
 		 */
-		i = 300 + ((unsigned)(arc4random() & 0xff00) >> 7);
+		i = 300 + ((unsigned)(cprng_fast32() & 0xff00) >> 7);
 
 		callout_reset(&sp->ch[IDX_CHAP], i * hz, chap.TO, sp);
 	}
@@ -4286,7 +4287,7 @@
 sppp_chap_scr(struct sppp *sp)
 {
 	uint32_t *ch;
-	u_char clen;
+	u_char clen = 4 * sizeof(uint32_t);
 
 	if (sp->myauth.name == NULL) {
 	    /* can't do anything useful */
@@ -4297,11 +4298,7 @@
 
 	/* Compute random challenge. */
 	ch = (uint32_t *)sp->myauth.challenge;
-	ch[0] = arc4random();
-	ch[1] = arc4random();
-	ch[2] = arc4random();
-	ch[3] = arc4random();
-	clen = 16;	/* 4 * sizeof(uint32_t) */
+	cprng_strong(kern_cprng, ch, clen);
 
 	sp->confid[IDX_CHAP] = ++sp->pp_seq[IDX_CHAP];
 
Index: net/npf/npf_nat.c
===================================================================
RCS file: /cvsroot/src/sys/net/npf/npf_nat.c,v
retrieving revision 1.6
diff -u -b -r1.6 npf_nat.c
--- net/npf/npf_nat.c	2 Feb 2011 02:20:25 -0000	1.6
+++ net/npf/npf_nat.c	31 Oct 2011 04:29:25 -0000
@@ -87,6 +87,8 @@
 #include <sys/kmem.h>
 #include <sys/mutex.h>
 #include <sys/pool.h>
+#include <sys/cprng.h>
+
 #include <net/pfil.h>
 #include <netinet/in.h>
 
@@ -319,7 +321,7 @@
 	u_int n = PORTMAP_SIZE, idx, bit;
 	uint32_t map, nmap;
 
-	idx = arc4random() % PORTMAP_SIZE;
+	idx = cprng_fast32() % PORTMAP_SIZE;
 	for (;;) {
 		KASSERT(idx < PORTMAP_SIZE);
 		map = pm->p_bitmap[idx];
Index: net80211/ieee80211_netbsd.c
===================================================================
RCS file: /cvsroot/src/sys/net80211/ieee80211_netbsd.c,v
retrieving revision 1.19
diff -u -b -r1.19 ieee80211_netbsd.c
--- net80211/ieee80211_netbsd.c	7 Oct 2011 16:51:45 -0000	1.19
+++ net80211/ieee80211_netbsd.c	31 Oct 2011 04:29:25 -0000
@@ -46,6 +46,8 @@
 
 #include <sys/socket.h>
 
+#include <sys/cprng.h>
+
 #include <net/if.h>
 #include <net/if_media.h>
 #include <net/if_ether.h>
@@ -640,14 +642,7 @@
 void
 get_random_bytes(void *p, size_t n)
 {
-	u_int8_t *dp = p;
-
-	while (n > 0) {
-		u_int32_t v = arc4random();
-		size_t nb = n > sizeof(u_int32_t) ? sizeof(u_int32_t) : n;
-		(void)memcpy(dp, &v, nb);
-		dp += sizeof(u_int32_t), n -= nb;
-	}
+	cprng_fast(p, n);
 }
 
 void
Index: netinet/in.c
===================================================================
RCS file: /cvsroot/src/sys/netinet/in.c,v
retrieving revision 1.140
diff -u -b -r1.140 in.c
--- netinet/in.c	28 Oct 2011 22:23:54 -0000	1.140
+++ netinet/in.c	31 Oct 2011 04:29:26 -0000
@@ -110,6 +110,8 @@
 #include <sys/syslog.h>
 #include <sys/kauth.h>
 
+#include <sys/cprng.h>
+
 #include <net/if.h>
 #include <net/route.h>
 
@@ -401,7 +403,7 @@
 				ia->ia_broadaddr.sin_family = AF_INET;
 			}
 			ia->ia_ifp = ifp;
-			ia->ia_idsalt = arc4random() % 65535;
+			ia->ia_idsalt = cprng_fast32() % 65535;
 			LIST_INIT(&ia->ia_multiaddrs);
 			newifaddr = 1;
 		}
Index: netinet/ip_carp.c
===================================================================
RCS file: /cvsroot/src/sys/netinet/ip_carp.c,v
retrieving revision 1.46
diff -u -b -r1.46 ip_carp.c
--- netinet/ip_carp.c	19 Oct 2011 01:52:22 -0000	1.46
+++ netinet/ip_carp.c	31 Oct 2011 04:29:26 -0000
@@ -55,6 +55,7 @@
 #include <sys/ucred.h>
 #include <sys/syslog.h>
 #include <sys/acct.h>
+#include <sys/cprng.h>
 
 #include <sys/cpu.h>
 
@@ -877,9 +878,7 @@
 {
 	if (sc->sc_init_counter) {
 		/* this could also be seconds since unix epoch */
-		sc->sc_counter = arc4random();
-		sc->sc_counter = sc->sc_counter << 32;
-		sc->sc_counter += arc4random();
+		sc->sc_counter = cprng_fast64();
 	} else
 		sc->sc_counter++;
 
Index: netinet/ip_id.c
===================================================================
RCS file: /cvsroot/src/sys/netinet/ip_id.c,v
retrieving revision 1.14
diff -u -b -r1.14 ip_id.c
--- netinet/ip_id.c	5 Nov 2010 01:35:57 -0000	1.14
+++ netinet/ip_id.c	31 Oct 2011 04:29:26 -0000
@@ -35,6 +35,7 @@
 #include <sys/param.h>
 #include <sys/kmem.h>
 #include <sys/mutex.h>
+#include <sys/cprng.h>
 
 #include <net/if.h>
 #include <netinet/in.h>
@@ -54,7 +55,7 @@
 static inline uint32_t
 ipid_random(void)
 {
-	return arc4random();
+	return cprng_fast32();
 }
 
 /*
